Craftsman homes come in two distinct styles: bungalow and four-square. This is a classic Craftsman four-square, Warwick, NY, c. 1910.

Two stories, four nearly square sides, hipped roof and hipped dormers in the attic story (that show great skill in framing) are all Craftsman. The double windows in the dormers were used in the more expensive homes of the era.

Classic Craftsman Four-Square

Edges to Rubies The Complete SketchUp Tutorial


simple house with edge deleted

Chapter 2—Laying the Foundation

These "warning" boxes generally alert you to problems. This one's different. It's about opportunity.

Right now, cruise to forums.sketchucation.com. When you get there, click the Registration/Login Help box. At the next page click the Register Here link. Register. Go to the Newbie Forum and say "hi". Tell them, "Martin says this is the best newbie forum on Earth."

This is the best newbie forum on Earth! No question is considered dumb in the Newbie Forum. It's expected that you don't have enough experience to do a proper search. When you ask your first question, you may be amazed at the speed of the replies.

Starting right here, we're going to work on a carriage house designed in the Craftsman bungalow style. This style became popular a century ago and is now enjoying a resurgence.

My carriage house is going to be built as if it were located in the northeastern U.S., which is where I live. If you're in Florida, you wouldn't put in a basement. (It will fill up with water and then alligators.) You'd use a simple slab. You will learn a lot from drawing my basement, however. You can email it to someone who lives up north.

A Working Directory

We will be creating more or less permanent files as we build our carriage house. To store them, create a working directory. On a PC, C:\carriage_house would be good. (Mac? /home/virginia/carriage_house would be good if your username is virginia.)

Make your working directory. (Don't know how to make a directory? Ask for help. No one to ask? Ask Google: "tutorial making working directory".) The first time you ask SketchUp to Save, it will default to My Documents (Mac?). Tell it you want to save in your working directory and that will be the default from then on.

PC users: The Windows OS encourages you to put all your files in a folder called My Documents. This is user hostile. Picture a well-organized cabinetmaker's workshop with every tool in place. You want that sort of computer.

Excavation

Excavation is easy in SketchUp. There's no bedrock lying where you want to dig.

We'll lay down a simple rectangle. First, we need to find the right size.

Sizing is an issue. Here in the U.S. we have not migrated to the International System of Units (aka SI—we call it the metric system). Note to Americans: this is just plain stupid. Metric domestic construction is uniformly measured in millimeters. This means our sensible neighbors never need to use a decimal point, never mind our silly fractions. Note to everyone else: I'd love to change, but you can't do that unilaterally. My lumberyard's goods are all measured in feet and inches.

SI-based material is very similar to American material. The thickness of wallboard required for fire retardency doesn't change whether you measure in fractions of an inch or millimeters. The metric equivalent of our four by eight feet—1220x2440—is very near four by eight. (The limiting factor: how much weight a worker can carry. Again, it doesn't matter how you measure it. Wallboard is heavy.)

If you are very proficient in metric construction measurements, you can translate my dimensions as you go along. If you are not well-versed in construction sizes, just suffer along with us Americans and use our silly units. (I'll blame the British. Our system used to be English units. To be fair, though, the British have had enough sense to switch. To be precise, the British have had enough sense to almost switch.)

Templates

Ctrl+N (for File/New) and Sang's back.

Sang and other template problems  

Uh, there's no bedrock here, but the Google dude, Sang, is definitely in the way. I'm tired of deleting him. (It's probably an honor to be where Sang is, but I wonder how it feels to be the most deleted man in the world.) Also, those axes aren't arranged my way. Let's make a template that will come up every time we say File/New (or Ctrl+N, or start SketchUp).

You could use a window selection to delete Sang. A window selection is done by tapping the spacebar to get the select tool, then dragging a window from left to right (top to bottom or bottom to top, as you prefer). Everything completely within the window is selected. If you drag the other way, from right to left, you make a crossing selection. This selects everything even partly within or touching the selection window. Try both on poor Sang and then Tap Delete or right-click Erase, for the last time.

Next, you'll need to orbit to orient the axes in a way that will be helpful for our project.

Warning: orbiting an empty model is either buggy or beyond my comprehension. Dragging a rectangle before you orbit slays this dragon.

properly oriented axes 

Now we'll go off topic, but not for long, and not without reason.

Sample photorealistic rendering  

For years in the computer rendering field, photorealistic results were the big thing. People achieved some spectacular results as this graphic shows. (Thank you, Wikipedia, computer rendering article.)

Well, the pendulum keeps swinging. Now SketchUp prominently features NPR (non-photorealistic rendering). Through the magic of styles, a topic I will mention only here, you can make your model look like a pencil drawing, a watercolor, felt-tip pens on whiteboard or whatever your whimsy fancies. This can be a lot of fun. It can be used by design professionals who want to show a model to clients as if it were a quick pencil sketch, so the client feels more free in suggesting changes.

SketchUp defaults to having some of this NPR turned on. You see it in the corners. I don't want it.


Styles window  

Click Window/Styles. The tabs (Select, Edit, Mix) form a tab bar. Click Edit. Those boxes under the Edit tab are sub-tabs. Click the wireframe one on the far left if your SketchUp didn't default to Edge.

Use the Edit tab to turn off everything except Display Edges, as you see to the left.

Play time!

Style selection dialog  

The Styles dialog to the left is off topic and without reason. Before you go here, set a strict limit on the amount of time you will spend going, "Oh, wow!" and "Amazing!". Ten minutes would be sensible. Ten hours would not. Don't say I didn't warn you.

To begin, model something. Rebuilding the simple house will work.

Choose Window/Styles, Select tab. There are great effects, here. From the Select tab you can choose from lots of ready-made styles. From the Edit tab you can customize the ready-made stuff. Mix lets you mix styles together, if you really can't get enough of this stuff.

Later, when I'm not around, go back here and try some of this stuff. It's amazing.

For this tutorial, it's off topic. When you're ready to get back to work, choose Default Styles in the dropdown and select Default Style. Choose File/New and drag out a rectangle.

This template is almost ready, but there's one more thing. How big is that rectangle?

Delete the rectangle and drag out another one. Keep your eye on the lower-right corner of SketchUp. There is a text box there, the Value Control Box (VCB). It displays your rectangle's size. The one in the screen shot here is about 2" long. After you start to drag out but before the second click, leave the mouse and type—29', 26' Enter—to get a carriage-house-sized rectangle. You'll need a Shift+Z to get it back in view.

Jargon note: The VCB in the latest Google docs is named the "Measurements Toolbar". It used to be, and still is, the VCB in the hundreds of online resources you can find for SketchUp. I'm sticking with tradition.

You do not type in the VCB. It's not an input device. You just type. Your typing is ignored until you press Enter. Advantage: no need to click to get focus in the VCB. Disadvantage: no way to edit after you press Enter. You can retype as often as you need.

Orbit to get the origin facing you. Green axis on the left and red on the right. This tutorial, not SketchUp, depends on this orientation.

The quick way to clean up before saving this template: use both hands. Double-click the rectangle and tap Delete. Now use the File/Save as Template... dialog. (No, that's not File/Save As...; it's File/Save as Template....)I named mine "new" (not a moment of creative inspiration). You must press Tab after you type the name. I accepted its suggestion, "new.skp", as the file name and clicked Save.

When you launched SketchUp you were given a menu of standard templates and asked to choose one. If you chose a sensible metric template (sensible if you live in almost every nation of the world outside the U.S.) you may want to choose Window/Preferences/Template to work in American units for this tutorial.

Back to the Foundation

We are now starting the carriage house.

My dimensions are:

Absent the stairway, the garage exterior would be a 25'4" square (24' interior plus an 8 inch wall on every side). With the stairway, the garage is 28'4" by 25'4".

Press Ctrl+N. Tap R and start dragging up. (You want the carriage house in the positive portion of the red and green axes.) Type 28'4,25'4—last reminder: you must press Enter. (If inches are your default unit, you don't have to type the inch symbol. In the rest of the world, you can type m or cm or mm. In domestic architecture, choose mm as your default and never type anything except the digits. Just don't expect to buy your supplies in an American lumber yard.) Use Window/Model Info/Units tab if you want to change units.

You've got the outline of the outside of the basement walls. Now you need the inside of the walls. There are lots of ways to do this, but one is dead simple.

image of offset tool cursor 

Let me introduce the oFFset tool. It's only problem is the first letter. (O is for Orbit, which you do far more often than oFFset.) F is for oFFset. Tap an F and you get the oFFset tool.

If your mouse pointer is not over your rectangle, move over it.

You followed instructions, but nothing happens? Try a little wriggle of your wrodent. If you were using the Move tool, for example, spacebar for Select changes to the Select tool but doesn't replace the Move pointer. A wriggle of the wrodent fixes the pointer. Neither the oFFset tool nor PushPull autoselects a face if they are over a face. Again, a wrodent wriggle will wake them up.

When the oFFset pointer is over a face, its tooltip says, "On Edge".

offsetting to a bigger face 

After tapping F, move the oFFset tool over a face. It autoselects the face. Drag a little and it draws an offset version of the face's bounding edges, inside the face. Drag from inside to outside of the face to offset to a bigger face.

Now let's start again. Use Ctrl+Z to eliminate any offsets you have drawn. Click F for oFFset. Go over the face, if you aren't over already. Drag inside the face. Type 8. Press Enter. Eight inches is the thickness of exterior walls.

You now have a file worth saving. Begin with clicking File/Save As.... If this is your first save, your directory will default to something other than your working directory. Switch to your working directory and type "basement" as the file name. SketchUp automatically adds ".skp" to your name. From now on I'll abbreviate the instructions to "File/Save As... basement.skp". Ctrl+N for the following experiments.

PushPull Has Two Modes

To pour the concrete floor, you need to know that PushPull has two modes. A plain PushPull moves a face, stretching/shrinking any faces or edges that touch the face. A copying PushPull moves a copy of the original face, leaving the original intact. If the face you PushPull is not touching other geometry, PushPull defaults to copying. Otherwise it defaults to not copying.

A smallish rectangle 

Drag out a smallish Rectangle. Orbit to approximate these axes.

Two smallish rectangles 

Choose the Select tool and double-click. Tap M and tap Ctrl (Option). Drag a copy up the green axis.

Offsets inward added to rectangles 

With the Select tool, click outside to clear the selection. With oFFset, drag an offset in both rectangles.

One plain and one copying PushPull 

PushPull the first inner rectangle up. This is a non-copying PushPull. The rectangle that you PushPull moves, leaving its outline behind.

With the second inner rectangle, tap P and tap the Ctrl key, just as you did with the Move operation. A copying PushPull makes a copy of the face, pulls up the copy, but leaves the original face where it was.

The copying PushPull is the one you were using in Chapter 1.

View from below showing one face copied, one not copied 

Orbit to look at the underside of these rectangles. The second has the original face in place. You pulled up a copy.

Do some more Pushpulls. Alternate copying and non-copying Pushpulls. Predict the result of each PushPull before you try it. When your predictions become accurate, move on.

Pouring Concrete

I think I hear the concrete truck arriving. Just in time. File/Open... "basement.skp". No, you don't want to save a copy of Untitled.

Tap P for PushPull. Over the exterior walls, pull up a bit. Type 12 and Enter. No need to type the inch mark if inches are the default unit. (We don't pull up walls to full height until the very end. They can be horribly in the way.) Congratulations. You have walls. SketchUp defaulted to a copying PushPull.

Now pour the floor, 3 inches thick. Move your PushPull over the floor. Tap Ctrl because SketchUp will not default to copying. Pull up a bit. Type 3 and Enter. Your floor is poured.

Repeat Everything

At this point, there have been new tools, modes, techniques to learn at every turn. All of which has disguised the fact that this can be really fast and easy. Here I'll give you the opportunity to get good with the tools we've used so far. Press Ctrl+N and follow along. Two or three times, until you're really good. Then time yourself.

Item Keyboard Mouse Keyboard
Establish Dimensions R click origin inference, drag up 28'4,25'4 Enter
Outer Wall Interior F drag inside rectangle 8 Enter
Outside Walls P over wall, click, pull up 12 Enter
Floor P, Ctrl over floor, click, pull up 3 Enter
Repeat these until the process takes less than a minute. (Are you the competitive type? Under a half minute beats my time.) This process of using a tool and finishing with a length or distance in the VCB is the hallmark of precise sketching up.

At this point you are ready to save your work. I make it a habit to Orbit around and under my model before saving. Note that we are not under ground (negative blue axis) yet. Not to worry. We'll build our whole basement at ground level and then move it underground as the very last step.

Stairs, the Right Way

What goes in the basement? Mechanicals, such as a furnace and a water heater are typical. These get smaller every year and should be grouped to take as little space as possible. With those out of the way, the rest of the space is for whatever you like. Not entirely by coincidence, this basement is just about the size of my woodworking shop. You decide what you want for yours.

Whatever your plan, we'll need stairs to access this space.

Groups

A group is a set of edges and faces that you do not want connected to other parts of your model. Why would you want this? One is for making a throwaway guide.

Step outline on block 

Follow these steps to get a result like the one on the left. Ctrl+N. Then Rectangle, about 12 inches on the green axis and 12 in the negative part of the red axis. Zoom in. PushPull up 12. Orbit around to the "front" (the face that's looking toward the positive red axis). Use the Line tool to draw the outline of a step. Don't worry about sizes, this is a throwaway.

Step pulled out of block 

Next, PushPull the step out, as you see here. This is the technique we'll use to create our first step.

Now that the block we used as a throwaway guide has served its purpose, you want to delete it. Problem: if you triple-click you select the block and the step, too. They're both part of the connected geometry. ("Geometry" is official SketchUp jargon, meaning any bunch of edges and faces.)

OK, back to Ctrl+N. Don't save Untitled. This time, the new model is a keeper. File/Save As... "stairway.skp".

Making a group for a throwaway guide 

We want a cube about 12" on a side. Lay out your rectangle, zoom in, pull it up. Select all (Ctrl+A or triple-click the cube with Select tool); right-click the cube, click Make Group. Your group (12 edges and six faces) will not stick to other edges and faces.

Make sure your axes match the ones to the left.

Congratulations. You now have your first group. You see that it's a group as SketchUp draws a bounding box. (Groups and components take quite a bit of understanding, but very little doing.) We will now draw a precise step and pull it out to an exact width. When it's done, we'll click the guide block. Since it's a group, it's not connected to the step. Delete. The block's gone; the step remains.

The Tape Measure

A common step measurement is 9 inches deep (the "run") and 7 inches high (the "rise"). This makes a comfortable stairway. Rise and run are commonly fudged. The precise rise is often determined by ceiling height plus the thickness of the floor above divided by the number of steps. A common trick is to have each step extend out from the riser by an inch or two, so you get a 9-inch wide step, but you save some space in the total run. We'll not fudge at all (until we get to the attic steps where we'll fudge a whole lot).

How do you draw the lines that outline each step? You bring in the Tape measure and lay out construction guides. The Tape measure creates guides if you start it on an edge (not at a point, such as an Endpoint). It also lays out guides if you start it at another construction guide.

Construction guides on block 

Create your own: "T" gets the Tape measure. Click the bottom edge (not corners) of the block and move up. Type 7 and press Enter. Repeat from the left edge to get a 9 inch run guide. From each guide draw another. Tape down from the horizontal guide and right from the vertical one. I've used 1.5 inches (the thickness of American dimension lumber).

Tape one more guide 1.5 from the left edge.
Step outline drawn with the Line tool 

Now tap L and use the Line tool to draw the outline of the step. At each end point you'll have a clear inference (either an Endpoint or an Intersection).

Were you drawing the outside or the inside of a face? I don't know. If you have a mixture of gray and white, the inside of your step outline is facing you. If you see white on white (or gray on gray, if your backing block is gray) right-click your step outline and click Reverse Faces.

If you have a face, it will be a mixture of gray and white (SketchUp 7) or it will just be white (SketchUp 7.1). Click it to be sure.


If you don't have a face go over your lines again. Make sure you start and stop at the same point. Reverse faces to check. If you are still having trouble with a face, your lines are not coplanar. If you were drawing on a backing block, as suggested here, that is just about impossible.

Actually, whether you have an inside or an outside face depends on which way you drew the step—clockwise or counterclockwise.

Me? I don't worry about clockwise. I just draw and reverse faces as needed.

Once you have the outline drawn, PushPull it out 36 inches and then delete the guide box. Also Edit/Delete Guides.

A completed, single step 

It's not yet a component, but it's a complete step. You'll be surprised when you find out how close to a completed stairway you've come.

One last note on the Tape measure. If you start the Tape measure at a point, it measures. One click anchors one end of the measure. Just pointing at another point gives you a measurement in the VCB and as a tool tip at the Tape pointer.

Second step stacked on first 

Steps will stack as you see on the left. You need a 10.5 inch step to have a nine-inch run.

It would be a good idea to use your Tape measure to check the rise and run of your step. (Since rise and run meet at the top-left corner, one click at that point will give you both measurements. Try it.)

Making a Component

The first step is to select your geometry. Spacebar up the Select tool and triple-click your step. Then tap G and you get the Create Component dialog box.
The Create Component dialog box

Type a name and click Create, ignoring the rest of the dialog. A meaningful name is important, but as you see here, it doesn't have to be a long name. After you click Create, you've got a component. Whether your component is selected (you see its bounding box) or not (no bounding box) depends on your SketchUp version.

Why a component, not a group? Groups are more compact and faster. Always use groups.

Groups don't have names (unless the modeler is meticulous). Additionally, the Ruby API does a nice job with components, but doesn't really handle groups. Always use components.

"Ambivalent? Well, yes and no." Jimmy Buffett

A good rule is this: If you have just one (our guide block) use a group. If you will have more than one you want components.

Both groups and components are space-efficient. The first one is slightly bigger than its visible contents. Additional copies take only a few bytes each.

You can change a group or component, but the effect is very different. If you change a group, it is changed. Other groups are unaffected. If you change a component, every component of the same type is changed. In the next chapter we'll create a carriage-house door component. With a second door, and some magic, we'll have a left/right pair. As we complete work on the left door, you'll see symmetric changes on the right door. It's slick.

Precision, Multiplying Moves

So far, our moves have been careless, a bit like drawing lines without End point inferences. Moves should almost always be done by snapping one Endpoint (or Intersection, Origin, ...) inference to another. Moves can also create one or more copies, which is perfect for creating a stairway out of step components. Let's start.

Performing a precise movement 

If you don't have the bounding box, click the component with the Select tool.

Tap M (Move cursor appears). Tap (don't hold, just tap) Ctrl. The pointer adds a "+". Click on the bottom right of the riser. Move to the top-right corner of the original step and click again. You've mated End point to End point inferences. The move is precise, and you've created your second step.

Without doing anything else, immediately after the move type "14x" (as in 14 times, don't type the quotes). (No more reminders about pressing Enter after you type, remember?) You'll probably need to Shift+Z to see the whole thing. You've built a stairway! It's 15 steps long and tall. (The original, plus 14 copies.) Time to Ctrl+S.

Technically, you've created an outer array of step components. We'll come to the inner array when we make our furniture in Chapter 8.

Editing a Component

Groups and components are closed. You cannot edit them without opening them for edit. Try this.

Spacebar up the Select tool. Click the component. Your bounding box appears, showing you that it's a component. Now double-click it, to enter component edit mode.

Editing a component 

A large bounding box replaces the tight one, showing you that your component is open for editing.

Try a PushPull on the side of the step. Every other step gets the same PushPull. Editing one component edits all components of the same type.
Now reopen "stairway.skp". Yes, you do want to revert back to the saved version.

The Ruby Console

The Ruby Console was created for programmers working on "rubies"—programs that automate some repetitive SketchUp task. It turns out that it is a very useful tool for non-programmers, too. It's particularly adept at odd angles. It will simplify modeling the bannister, the next and last part of our stairway. In Chapter 12 we'll create a better stairway with just 8 commands typed in the Ruby Console.

Here we have amazing power in a simple tool. Open it with Window/Ruby Console. In the input area (white) type "2+2". You get:

2 plus 2 in the Ruby Console

You could use the Ruby Console to compute the height of the bannister at the far end. It's 7 inch rise for each of 15 steps, a 7 inch rise to the floor above the top step and then 36 inches above the floor. You type 15*7 + 7 + 36.

Bannister height, far end, in the Ruby Console

Sketchup stores all lengths in inches. There is a special class available that makes length conversions painless. The following table explains itself at its top.

you type alternating blue/green boxes explain the conversation
Ruby Console answers
10.cm How long, in inches, is 10 centimeters?
3.93700787401575
10.m What about 10 meters?
393.700787401575
10.km 10 kilometers is a lot of inches!
393700.787401575
10.mm 10 millimeters?
0.393700787401575
If you are not in the U.S., you want to convert to international units.
10.to_cm What is 10 inches, in centimeters?
25.4
72.to_mm 6 feet, in millimeters?
1828.8
If you can type it into the VCB, convert a string to a length in inches with to_l
"10cm".to_l 10 centimeters, in inches. (10.cm is easier.)
3.93700787401575
"5'5 1/5".to_l 5 feet, 5 and 1/5 inches, in inches.
65.2
"5'5 1/5".to_l.to_mm In one step, give me that in millimeters.
1656.08

On to Ruby programming, in a tiny way. We want to add a face. You add the face to the "entities" collection of the "active_model." (PC users: Mac folks can have more than one model. Jealous?) Type: ents = Sketchup.active_model.entities . Except for the number, it looks like this:

An ents object in the Ruby Console

Did that come out wrong? "Sketchup" in Ruby has a capital "S" and a lowercase "u". Check everything carefully. Press the up arrow to edit the previous entry and retry it.

Now we're ready to add a new face. In SketchUp, a point in space is defined by three numbers enclosed in brackets: [r, g, b]. You can use specific points with, for instance, the Move tool. In Ruby programming, a point in space is defined as an array of three numbers: [r, g, b]. It's quite convenient that these are identical. The r is the location on the red axis. The g and b are locations on the green and blue axes.

Let's run up the main on your sloop, sailing up the green axis. The tack (bottom corner at the mast) is at 0 on the red axis, 0 on the green axis and lets say four feet up the blue axis. That's [0,0,48]. Your mast is 25 feet tall. The main's head is at [0,0,300]. The clew (lower, rear corner) is 15 feet behind the mast at [0, -180, 48].

Using the Ruby Console to draw a main sail 

Save your basement and then Ctrl+N. Into your Ruby console type ents.add_face [0,0,48],[0,0,300],[0,-180,48] and press Enter.

Your model sloop now has three edges and a face.

Click in your SketchUp window to give it focus. Ctrl+Z. Your mainsail is gone!

Click in your Ruby Console to give it focus. Up arrow, Enter. Your mainsail is back!

Jib overlapping main 

The jib is trickier. Let's say the tack is 3 feet up and 15 feet ahead of the mast: [0,180,36]. We'll use the peak of the main as the peak of the jib. The jib overlaps half the main and is sheeted in five feet to starboard, three feet above the waterline: [60,-90, 36].

You tell your Ruby console ents.add_face [0,180,36],[0,0,300],[60,-90,36]. Instant sloop!

It's when your edges and faces are not parallel to the three axes that the Ruby Console shows its merit. To model that jib without it requires that you know exactly where the corners are, as you do when you use the Ruby Console. Then you start Taping out construction guides. Thought experiment: how many guides would you need to position the jib?

All of which leads us back to the bannister, another thing that is at an odd angle.

Uh, oh. The Bannister.

There's no bannister. You want a bannister. Your building code probably requires it. Good sense also requires it. Bannisters used to drive me crazy.

Think about how you can make a bannister. (If the dog ate your scientific calculator and your trigonometry is all rusty, the angle of a 7:9 stairway is about 37.875 degrees. That fact never helped me.) A rounded bannister is comfortable, but I'll settle for a rectangular approximation. Think about it as long as you like. I'll wait.

The fact is, that this is a tough one, unless you use the Ruby console. Bannisters are particularly tough because when you zoom in close enough to do some work on an end, you can't see the other end. It's near impossible to Line or Rectangle from one story to the next.

I actually don't know how to design a bannister correctly. There's a great deal that is specified by your local building code. You'll need to do some research if you want something built to your design. Mine will look sufficiently bannister-like to be used in a model.

Let's do a 1.5 inch, square bannister. (Don't worry, nobody gets splinters in cyberspace.) We'll put it 1.5 inches out from the wall.

Locating 3d points 

Orbit your stairway until the origin faces you. It should look something like what you see here.

You need a clear idea of what goes where. The red axis places points on the width of the stairs. Your bannister will be between 1.5 and 3 on the red axis. The green axis is the run of the stairway. Blue is the rise.

The bottom of the bannister as a skinny rectangle 

You need to figure out the 3D locations of the bannister's bottom. They form the long, skinny rectangle you see here.

You need a simple text editor. In Windows, NotePad, is adequate. TextEdit on your Mac. I'd be using Kate right now if SketchUp ran in Linux. Type this: [r,g,b],[r,g,b],[r,g,b],[r,g,b]. The "[r,g,b]" need to be replaced with numbers. I used to try to get one point at a time. I quit that in favor of working one fact at a time.

Assume that the first point is the bottom corner nearer the wall and the rest work around the rectangle, counter-clockwise: bottom-left, bottom-right, top-right, top-left. The r coordinate will be 1.5 next to the wall (the bannister is 1.5 inches away from the wall), and 3 away from the wall (1.5 away plus 1.5 wide), so you can edit those in: [1.5,g,b],[3,g,b],[3,g,b],[1.5,g,b].

Green is zero at the lower end: [1.5,0,b],[3,0,b],[3,g,b],[1.5,g,b].

Start your bannister 36 inches above the bottom step. It's 7 inches high. Now you've got: [1.5,0,43],[3,0,43],[3,g,b],[1.5,g,b].

Congratulations. You're up to the harder ones. The total run is 9 inches times 15 steps: [1.5,0,43],[3,0,43],[3,135,b],[1.5,135,b].

Finally, your rise is 7 inches times 15 steps, plus 7 inches for the height of the floor above the last step plus 36 inches for the height of the bannister above the floor: [1.5,0,43],[3,0,43],[3,135,148],[1.5,135,148].

In practice, you can think all these through very carefully and not proceed until you are convinced you have it right. I think only long enough to get some values to put in and then test it out. Not right? Ctrl+Z fixes the model in SketchUp and the up arrow lets you edit your previous line in the Ruby console.

Now, in your Ruby console, type f = ents.add_face . In your text editor, select the points and copy them to the clipboard. In the Ruby Console, paste in the points and press Enter.

Magic! You've got the bottom of your bannister.

You see that bannister face. Right away you want to look around at it. You tap "o" to Orbit. Sorry. That "o" is now in the Ruby Console and you are not orbiting. Backspace to lose the "o". Click on the SketchUp window to give it focus. Now tap "o" to Orbit. Click on the Ruby Console for the next step.

Why did we say f = ents.add_face ...?

You've seen that now you can add geometry through either the SketchUp model or through the Ruby Console. You can also apply commands either way. You can PushPull that bannister in the usual way, or you can do it in Ruby: f.pushpull 1.5. Note: no caps in Ruby's pushpull method.

A pushpull in the Ruby Console

Your bannister is complete, without errors. (And without the hardware you need to attach it to the wall. If you spend the time to model the hardware, no one will notice any of your meticulous work. Sorry.) Time to install the stairs in your basement. You can close your Ruby Console at this point.

Adding the Stairway to the Basement

If you haven't yet done so, save "stairway.skp". Open "basement.skp". Begin by orbiting until you see the inside base of the wall parallel to the red axis.

Adding a construction guide for the stairway 

You need to Tape a construction guide, 6 feet out from the inside base of the front wall (on the red axis). The intersection of this guide and the inside base of the wall parallel to the green axis will be our inference point for precisely locating the stairs.

Viewing the inference point for the stairway 

Now orbit back to get the view shown on the left. Zoom in so you can place your stairs.

Now we're ready. File/Import... and choose your stairway. When you import, your whole model is turned into a component. If you import from stairway.skp, your component will be named "stairway". More happens.

SketchUp initiates a Move. It does the first click at the origin of the geometry you are importing. It makes a guess about the blue axis location. In this case it will guess that you want to place your stairway on the basement floor. You continue the move, sliding your stairway to the intersection of your guide and the wall. Click the inference point. Your stairway is perfectly positioned! Click Edit/Delete Guides. Save.

Basement Walls

We want an interior (6-inch) wall beside the stairway. With the select tool, (this is your very last "tap the spacebar" reminder) click away from the stairway so the "I'm selected" bounding box disappears. Rectangle from the front corner of the stairs, 135,6 (or maybe 6, 135). PushPull it up to 8'4. (And thank Bart Humphries for pointing out the error in the original!)

Last step: PushPull the outside walls up 7'7. (Remember, you already did the first 12 inches.) Save.

Mental note: Later we'll need to add a 12" thick ceiling that will also be the garage floor.

Finishing Moves

Double-check height. Orbit and Zoom in close to where the stairway appears above the outside wall. Measure. It should be exactly 5 inches. The seven inch rise above the last step to the ground floor gives you exactly 12 inches for floor thickness.

Oh No

Mine didn't check! It was out about 5/16 of an inch. Huh? Went back to stairway model. Measured 8'9", that is 105", which, when divided by 15 steps is a perfect 7" per step. (Working in feet and inches is horrid. When will we learn?) The stairway must not have been on the basement floor during the import. Solution: delete it and import again. Double check that the tooltip says "On face". Now the top step is a perfect 5 inches above the outside walls.

Last step: we've worked at ground level, upward, which is convenient during construction. Now we want to sink the basement. We need to sink 9'7 (wall height)plus 12 inches (floor height). Select everything. If you triple-click the basement you'll need to shift-click the stairway. Components and groups are not connected. Use the Move tool. Make your first click at the origin. Go straight down. (Make sure your tooltip reads "On blue axis".) Type the distance. Double check that your walls are exactly 12 inches below the origin.

Finished basement

Congratulations. You have launched your SketchUp career. It's time to replace that "Getting Started" toolbar with the "Large Tool Set" toolbar.


Simple house, edge removed. View of apartment contents. Carriage house ground floor.